// RingWorm v 1.2 (c) 1998 Graham Mitchell <mitchell@onr.com> - 19 Oct 1998

// Constants

/*
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License (LICENSE.TXT) for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software Foundation,
	Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef __CONST_H
#define __CONST_H

// dimensions
const int WIDTH=320;
const int HEIGHT=200;

const int RADIUS=HEIGHT/100;
const int SPEED=RADIUS/2+1;

const int INITIAL_LENGTH = 15;

const int PIZZA_MIN=4;
const int PIZZA_MAX=15;
const int PIZZA_VAR=PIZZA_MAX-PIZZA_MIN;

// colors
const int PURPLE=32;
const int GREEN=48;
const int RED=64;
const int GREY=24;

const int BLANK=15;

// angles
const int ANG_N = 90;
const int ANG_NW = 135;
const int ANG_W = 180;
const int ANG_SW = 225;
const int ANG_S = 270;
const int ANG_SE = 315;
const int ANG_E = 0;
const int ANG_NE = 45;

// game logic

bool WRAP = false;
bool BOUNCE = false;
bool CHECK_COLLISIONS = true;
bool BENCHMARK = false;
bool USE_FOOD = true;
bool SHOW_FPS = false;
bool SHOW_SCORE = true;
bool GAME_QUIT = false;
bool PROG_QUIT = false;

int PLAYERS = 1;
int TURBO = 1;
int PIZZAS = 1;

// and a struct I use throughout
struct Point
{
	float x;
	float y;
};


#endif
