// RingWorm v 1.2 (c) 1998 Graham Mitchell <mitchell@onr.com> - 19 Oct 1998

// item class

/*
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License (LICENSE.TXT) for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software Foundation,
	Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include "const.h"
#include "item.h"
#include <allegro.h>


Item::Item()
{
	// Create some suitable junk values that we'll overwrite in init()
	loc.x = loc.y = 1;
	color = BLANK;
	r = 1;
}


void Item::init( Point p, int radius, int init_color )
{
	// color and size
	color = init_color;
	r = radius;

	// inital location
	loc = p;

}


void Item::draw()
{
	// draw my current location

	circlefill(screen,(int)loc.x,(int)loc.y,r,color);
	circlefill(screen,(int)loc.x,(int)loc.y,r-2,BLANK);

}

void Item::erase()
{
	// clear my current location

	circlefill(screen,(int)loc.x,(int)loc.y,r,BLANK);

}



bool Item::touches( Point p , int r2 )
{
	// check if given Point is within r2 of me

	Point diff;

	float min_dist_sqr = (r+r2)*(r+r2);
	float hyp_sqr;

	// get distance from current to p

	diff.x = loc.x - p.x;
	diff.y = loc.y - p.y;

	hyp_sqr = diff.x*diff.x + diff.y*diff.y;

	// now see if it's too close

	if ( hyp_sqr <= min_dist_sqr )
		return true;

	// if we're still here, it must not touch us.

	return false;
}


void Item::relocate(int new_x, int new_y)
{
	loc.x = new_x;
	loc.y = new_y;
}

