// RingWorm v 1.2 (c) 1998 Graham Mitchell <mitchell@onr.com> - 19 Oct 1998

// header for worm class

/*
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License (LICENSE.TXT) for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software Foundation,
	Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef __WORM_H
#define __WORM_H

#include "const.h"
#include "queue.cpp"

class Worm
{

public:

	Worm();

	void init(	int num,
				int x_init, int y_init, int radius,
				int init_color,
				const unsigned char left, const unsigned char right,
				float spd, int ang
			);

	void draw();
	bool update();

	void award( int pts ) { points += pts; }

	Point location() { return loc; }
	int radius() { return r; }
	int score() { return points; }
	int length() { return len; }

	bool touches( Point, int );

	void grow(int);
	void relocate(int new_x, int new_y);
	char* report();

private:

	void reflect(int);

	int trail, color, cindex, cbase;
	int r, angle, change, len, ident;
	int points;
	float speed, dx, dy, friction;
	Point loc, old_loc;

	unsigned char K_LEFT;
	unsigned char K_RIGHT;

	Queue<Point> buf;

};

#endif
